Index: /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/BoolArray.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/BoolArray.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/BoolArray.cs	(revision 17253)
@@ -21,7 +21,7 @@
 
 using System.Text;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HEAL.Attic;
 
 namespace HeuristicLab.Data {
@@ -36,5 +36,5 @@
     public BoolArray() : base() { }
     public BoolArray(int length) : base(length) { }
-    public BoolArray(bool[] elements) : base(elements) { }
+    public BoolArray(bool[] elements, bool @readonly = false) : base(elements, @readonly) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -67,4 +67,8 @@
       }
     }
+
+    public new BoolArray AsReadOnly() {
+      return (BoolArray)base.AsReadOnly();
+    }
   }
 }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/BoolMatrix.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/BoolMatrix.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/BoolMatrix.cs	(revision 17253)
@@ -22,7 +22,7 @@
 using System.Collections.Generic;
 using System.Text;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HEAL.Attic;
 
 namespace HeuristicLab.Data {
@@ -39,7 +39,7 @@
     public BoolMatrix(int rows, int columns, IEnumerable<string> columnNames) : base(rows, columns, columnNames) { }
     public BoolMatrix(int rows, int columns, IEnumerable<string> columnNames, IEnumerable<string> rowNames) : base(rows, columns, columnNames, rowNames) { }
-    public BoolMatrix(bool[,] elements) : base(elements) { }
-    public BoolMatrix(bool[,] elements, IEnumerable<string> columnNames) : base(elements, columnNames) { }
-    public BoolMatrix(bool[,] elements, IEnumerable<string> columnNames, IEnumerable<string> rowNames) : base(elements, columnNames, rowNames) { }
+    public BoolMatrix(bool[,] elements, bool @readonly = false) : base(elements, @readonly) { }
+    public BoolMatrix(bool[,] elements, IEnumerable<string> columnNames, bool @readonly = false) : base(elements, columnNames, @readonly) { }
+    public BoolMatrix(bool[,] elements, IEnumerable<string> columnNames, IEnumerable<string> rowNames, bool @readonly = false) : base(elements, columnNames, rowNames, @readonly) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -73,4 +73,8 @@
     }
 
+    public new BoolMatrix AsReadOnly() {
+      return (BoolMatrix)base.AsReadOnly();
+    }
+
     #region IStringConvertibleMatrix Members
     int IStringConvertibleMatrix.Rows {
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/BoolValue.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/BoolValue.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/BoolValue.cs	(revision 17253)
@@ -23,7 +23,7 @@
 using System.Drawing;
 using System.Text;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HEAL.Attic;
 
 namespace HeuristicLab.Data {
@@ -41,5 +41,5 @@
     }
     public BoolValue() : base() { }
-    public BoolValue(bool value) : base(value) { }
+    public BoolValue(bool value, bool @readonly = false) : base(value, @readonly) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -81,4 +81,8 @@
     }
 
+    public new BoolValue AsReadOnly() {
+      return (BoolValue)base.AsReadOnly();
+    }
+
     #region IStringConvertibleValue Members
     bool IStringConvertibleValue.Validate(string value, out string errorMessage) {
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/DoubleArray.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/DoubleArray.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/DoubleArray.cs	(revision 17253)
@@ -21,7 +21,7 @@
 
 using System.Text;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HEAL.Attic;
 
 namespace HeuristicLab.Data {
@@ -36,5 +36,5 @@
     public DoubleArray() : base() { }
     public DoubleArray(int length) : base(length) { }
-    public DoubleArray(double[] elements) : base(elements) { }
+    public DoubleArray(double[] elements, bool @readonly = false) : base(elements, @readonly) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -67,4 +67,8 @@
       }
     }
+
+    public new DoubleArray AsReadOnly() {
+      return (DoubleArray)base.AsReadOnly();
+    }
   }
 }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/DoubleMatrix.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/DoubleMatrix.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/DoubleMatrix.cs	(revision 17253)
@@ -73,4 +73,8 @@
     }
 
+    public new DoubleMatrix AsReadOnly() {
+      return (DoubleMatrix)base.AsReadOnly();
+    }
+
     #region IStringConvertibleMatrix Members
     int IStringConvertibleMatrix.Rows {
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/DoubleValue.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/DoubleValue.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/DoubleValue.cs	(revision 17253)
@@ -23,7 +23,7 @@
 using System.Drawing;
 using System.Text;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HEAL.Attic;
 
 namespace HeuristicLab.Data {
@@ -41,5 +41,5 @@
     }
     public DoubleValue() : base() { }
-    public DoubleValue(double value) : base(value) { }
+    public DoubleValue(double value, bool @readonly = false) : base(value, @readonly) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -85,4 +85,8 @@
     }
 
+    public new DoubleValue AsReadOnly() {
+      return (DoubleValue)base.AsReadOnly();
+    }
+
     #region IStringConvertibleValue Members
     bool IStringConvertibleValue.Validate(string value, out string errorMessage) {
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/EnumValue.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/EnumValue.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/EnumValue.cs	(revision 17253)
@@ -22,7 +22,7 @@
 using System;
 using System.Drawing;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HEAL.Attic;
 
 namespace HeuristicLab.Data {
@@ -39,12 +39,6 @@
     }
 
-    public EnumValue() {
-      this.value = default(T);
-      this.readOnly = false;
-    }
-    public EnumValue(T value) {
-      this.value = value;
-      this.readOnly = false;
-    }
+    public EnumValue() : base(default(T)) { }
+    public EnumValue(T value, bool @readonly = false) : base(value, @readonly) { }
 
     [StorableConstructor]
@@ -61,4 +55,8 @@
       return Value.CompareTo(other.Value);
     }
+
+    public new EnumValue<T> AsReadOnly() {
+      return (EnumValue<T>)base.AsReadOnly();
+    }
   }
 }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/IntArray.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/IntArray.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/IntArray.cs	(revision 17253)
@@ -21,7 +21,7 @@
 
 using System.Text;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HEAL.Attic;
 
 namespace HeuristicLab.Data {
@@ -36,5 +36,5 @@
     public IntArray() : base() { }
     public IntArray(int length) : base(length) { }
-    public IntArray(int[] elements) : base(elements) { }
+    public IntArray(int[] elements, bool @readonly = false) : base(elements, @readonly) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -67,4 +67,8 @@
       }
     }
+
+    public new IntArray AsReadOnly() {
+      return (IntArray)base.AsReadOnly();
+    }
   }
 }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/IntMatrix.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/IntMatrix.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/IntMatrix.cs	(revision 17253)
@@ -22,7 +22,7 @@
 using System.Collections.Generic;
 using System.Text;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HEAL.Attic;
 
 namespace HeuristicLab.Data {
@@ -39,7 +39,7 @@
     public IntMatrix(int rows, int columns, IEnumerable<string> columnNames) : base(rows, columns, columnNames) { }
     public IntMatrix(int rows, int columns, IEnumerable<string> columnNames,IEnumerable<string> rowNames) : base(rows, columns, columnNames,rowNames) { }
-    public IntMatrix(int[,] elements) : base(elements) { }
-    public IntMatrix(int[,] elements, IEnumerable<string> columnNames) : base(elements,columnNames) { }
-    public IntMatrix(int[,] elements, IEnumerable<string> columnNames, IEnumerable<string> rowNames) : base(elements,columnNames,rowNames) { }
+    public IntMatrix(int[,] elements, bool @readonly = false) : base(elements, @readonly) { }
+    public IntMatrix(int[,] elements, IEnumerable<string> columnNames, bool @readonly = false) : base(elements, columnNames, @readonly) { }
+    public IntMatrix(int[,] elements, IEnumerable<string> columnNames, IEnumerable<string> rowNames, bool @readonly = false) : base(elements, columnNames, rowNames, @readonly) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -73,4 +73,8 @@
     }
 
+    public new IntMatrix AsReadOnly() {
+      return (IntMatrix)base.AsReadOnly();
+    }
+
     #region IStringConvertibleMatrix Members
     int IStringConvertibleMatrix.Rows {
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/IntValue.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/IntValue.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/IntValue.cs	(revision 17253)
@@ -23,7 +23,7 @@
 using System.Drawing;
 using System.Text;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HEAL.Attic;
 
 namespace HeuristicLab.Data {
@@ -41,5 +41,5 @@
     }
     public IntValue() : base() { }
-    public IntValue(int value) : base(value) { }
+    public IntValue(int value, bool @readonly = false) : base(value, @readonly) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -81,4 +81,8 @@
     }
 
+    public new IntValue AsReadOnly() {
+      return (IntValue)base.AsReadOnly();
+    }
+
     #region IStringConvertibleValue Members
     bool IStringConvertibleValue.Validate(string value, out string errorMessage) {
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/PercentArray.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/PercentArray.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/PercentArray.cs	(revision 17253)
@@ -21,7 +21,7 @@
 
 using System.Text;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HEAL.Attic;
 
 namespace HeuristicLab.Data {
@@ -36,5 +36,5 @@
     public PercentArray() : base() { }
     public PercentArray(int length) : base(length) { }
-    public PercentArray(double[] elements) : base(elements) { }
+    public PercentArray(double[] elements, bool @readonly = false) : base(elements, @readonly) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -77,4 +77,8 @@
       }
     }
+
+    public new PercentArray AsReadOnly() {
+      return (PercentArray)base.AsReadOnly();
+    }
   }
 }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/PercentMatrix.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/PercentMatrix.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/PercentMatrix.cs	(revision 17253)
@@ -22,7 +22,7 @@
 using System.Collections.Generic;
 using System.Text;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HEAL.Attic;
 
 namespace HeuristicLab.Data {
@@ -39,7 +39,7 @@
     public PercentMatrix(int rows, int columns, IEnumerable<string> columnNames) : base(rows, columns, columnNames) { }
     public PercentMatrix(int rows, int columns, IEnumerable<string> columnNames, IEnumerable<string> rowNames) : base(rows, columns, columnNames, rowNames) { }
-    public PercentMatrix(double[,] elements) : base(elements) { }
-    public PercentMatrix(double[,] elements, IEnumerable<string> columnNames) : base(elements, columnNames) { }
-    public PercentMatrix(double[,] elements, IEnumerable<string> columnNames, IEnumerable<string> rowNames) : base(elements, columnNames, rowNames) { }
+    public PercentMatrix(double[,] elements, bool @readonly = false) : base(elements, @readonly) { }
+    public PercentMatrix(double[,] elements, IEnumerable<string> columnNames, bool @readonly = false) : base(elements, columnNames, @readonly) { }
+    public PercentMatrix(double[,] elements, IEnumerable<string> columnNames, IEnumerable<string> rowNames, bool @readonly = false) : base(elements, columnNames, rowNames, @readonly) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -85,4 +85,8 @@
       }
     }
+
+    public new PercentMatrix AsReadOnly() {
+      return (PercentMatrix)base.AsReadOnly();
+    }
   }
 }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/PercentValue.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/PercentValue.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/PercentValue.cs	(revision 17253)
@@ -21,7 +21,7 @@
 
 using System;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HEAL.Attic;
 
 namespace HeuristicLab.Data {
@@ -51,7 +51,7 @@
     }
     public PercentValue() : base() { }
-    public PercentValue(double value) : base(value) { }
-
-    public PercentValue(double value, bool restrictToUnitInterval)
+    public PercentValue(double value, bool @readonly = false) : base(value, @readonly) { }
+    // TODO: suggest to remove the following constructor [ABE]
+    public PercentValue(double value, bool restrictToUnitInterval, bool @readonly = false)
       : base() {
       this.restrictToUnitInterval = restrictToUnitInterval;
@@ -59,4 +59,5 @@
         throw new ArgumentException("Value must lie in the interval [0,1].");
       this.value = value;
+      this.readOnly = @readonly;
     }
 
@@ -101,4 +102,8 @@
       }
     }
+
+    public new PercentValue AsReadOnly() {
+      return (PercentValue)base.AsReadOnly();
+    }
   }
 }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/StringArray.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/StringArray.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/StringArray.cs	(revision 17253)
@@ -26,7 +26,7 @@
 using System.Linq;
 using System.Text;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HEAL.Attic;
 
 namespace HeuristicLab.Data {
@@ -131,10 +131,10 @@
       elementNames = new List<string>();
     }
-    public StringArray(string[] elements) {
+    public StringArray(string[] elements, bool @readonly = false) {
       if (elements == null) throw new ArgumentNullException();
       array = new string[elements.Length];
       for (int i = 0; i < array.Length; i++)
         array[i] = elements[i] == null ? string.Empty : elements[i];
-      readOnly = false;
+      readOnly = @readonly;
       resizable = true;
       elementNames = new List<string>();
@@ -146,7 +146,8 @@
 
     public virtual StringArray AsReadOnly() {
-      StringArray readOnlyStringArray = (StringArray)this.Clone();
-      readOnlyStringArray.readOnly = true;
-      return readOnlyStringArray;
+      if (ReadOnly) return this;
+      var clone = (StringArray)this.Clone();
+      clone.readOnly = true;
+      return clone;
     }
     IValueTypeArray IValueTypeArray.AsReadOnly() {
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/StringConvertibleArray.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/StringConvertibleArray.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/StringConvertibleArray.cs	(revision 17253)
@@ -22,7 +22,7 @@
 #endregion
 
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HEAL.Attic;
 
 namespace HeuristicLab.Data {
@@ -37,5 +37,5 @@
     protected StringConvertibleArray() : base() { }
     protected StringConvertibleArray(int length) : base(length) { }
-    protected StringConvertibleArray(T[] elements) : base(elements) { }
+    protected StringConvertibleArray(T[] elements, bool @readonly = false) : base(elements, @readonly) { }
 
     protected abstract bool Validate(string value, out string errorMessage);
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/StringMatrix.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/StringMatrix.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/StringMatrix.cs	(revision 17253)
@@ -26,7 +26,7 @@
 using System.Linq;
 using System.Text;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HEAL.Attic;
 
 namespace HeuristicLab.Data {
@@ -178,5 +178,5 @@
       RowNames = rowNames;
     }
-    public StringMatrix(string[,] elements) {
+    public StringMatrix(string[,] elements, bool @readonly = false) {
       if (elements == null) throw new ArgumentNullException();
       matrix = new string[elements.GetLength(0), elements.GetLength(1)];
@@ -188,12 +188,12 @@
       rowNames = new List<string>();
       sortableView = false;
-      readOnly = false;
-    }
-    protected StringMatrix(string[,] elements, IEnumerable<string> columnNames)
-      : this(elements) {
+      readOnly = @readonly;
+    }
+    protected StringMatrix(string[,] elements, IEnumerable<string> columnNames, bool @readonly = false)
+      : this(elements, @readonly) {
       ColumnNames = columnNames;
     }
-    protected StringMatrix(string[,] elements, IEnumerable<string> columnNames, IEnumerable<string> rowNames)
-      : this(elements, columnNames) {
+    protected StringMatrix(string[,] elements, IEnumerable<string> columnNames, IEnumerable<string> rowNames, bool @readonly = false)
+      : this(elements, columnNames, @readonly ) {
       RowNames = rowNames;
     }
@@ -204,7 +204,8 @@
 
     public virtual StringMatrix AsReadOnly() {
-      StringMatrix readOnlyStringMatrix = (StringMatrix)this.Clone();
-      readOnlyStringMatrix.readOnly = true;
-      return readOnlyStringMatrix;
+      if (ReadOnly) return this;
+      var clone = (StringMatrix)this.Clone();
+      clone.readOnly = true;
+      return clone;
     }
 
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/StringValue.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/StringValue.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/StringValue.cs	(revision 17253)
@@ -22,7 +22,7 @@
 using System;
 using System.Drawing;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HEAL.Attic;
 
 namespace HeuristicLab.Data {
@@ -66,7 +66,7 @@
       this.readOnly = false;
     }
-    public StringValue(string value) {
+    public StringValue(string value, bool @readonly = false) {
       this.value = value != null ? value : string.Empty;
-      this.readOnly = false;
+      this.readOnly = @readonly;
     }
 
@@ -76,7 +76,8 @@
 
     public virtual StringValue AsReadOnly() {
-      StringValue readOnlyStringValue = (StringValue)this.Clone();
-      readOnlyStringValue.readOnly = true;
-      return readOnlyStringValue;
+      if (ReadOnly) return this;
+      var clone = (StringValue)this.Clone();
+      clone.readOnly = true;
+      return clone;
     }
 
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/TextValue.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/TextValue.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/TextValue.cs	(revision 17253)
@@ -20,7 +20,7 @@
 #endregion
 
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HEAL.Attic;
 
 namespace HeuristicLab.Data {
@@ -29,22 +29,11 @@
   public class TextValue : StringValue, ITextValue {
 
-    public TextValue() {
-      this.value = string.Empty;
-      this.readOnly = false;
-    }
-
-    public TextValue(string value) {
-      this.value = value ?? string.Empty;
-      this.readOnly = false;
-    }
+    public TextValue() : base() { }
+    public TextValue(string value, bool @readonly = false) : base(value ?? string.Empty, @readonly) { }
 
     [StorableConstructor]
     protected TextValue(StorableConstructorFlag _) : base(_) { }
 
-    protected TextValue(TextValue original, Cloner cloner)
-      : base(original, cloner) {
-      this.value = original.value ?? string.Empty;
-      this.readOnly = original.readOnly;
-    }
+    protected TextValue(TextValue original, Cloner cloner) : base(original, cloner) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/TimeSpanValue.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/TimeSpanValue.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/TimeSpanValue.cs	(revision 17253)
@@ -23,7 +23,7 @@
 using System.Globalization;
 using System.Text;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HEAL.Attic;
 
 namespace HeuristicLab.Data {
@@ -37,5 +37,5 @@
     }
     public TimeSpanValue() : base() { }
-    public TimeSpanValue(TimeSpan value) : base(value) { }
+    public TimeSpanValue(TimeSpan value, bool @readonly = false) : base(value, @readonly) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -80,4 +80,8 @@
     }
 
+    public new TimeSpanValue AsReadOnly() {
+      return (TimeSpanValue)base.AsReadOnly();
+    }
+
     #region IStringConvertibleValue Members
     bool IStringConvertibleValue.Validate(string value, out string errorMessage) {
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/ValueTypeArray.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/ValueTypeArray.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/ValueTypeArray.cs	(revision 17253)
@@ -26,7 +26,7 @@
 using System.Linq;
 using System.Text;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HEAL.Attic;
 
 namespace HeuristicLab.Data {
@@ -137,8 +137,8 @@
       elementNames = new List<string>();
     }
-    protected ValueTypeArray(T[] elements) {
+    protected ValueTypeArray(T[] elements, bool @readonly = false) {
       if (elements == null) throw new ArgumentNullException();
       array = (T[])elements.Clone();
-      readOnly = false;
+      readOnly = @readonly;
       resizable = true;
       elementNames = new List<string>();
@@ -146,7 +146,8 @@
 
     public virtual IValueTypeArray AsReadOnly() {
-      ValueTypeArray<T> readOnlyValueTypeArray = (ValueTypeArray<T>)this.Clone();
-      readOnlyValueTypeArray.readOnly = true;
-      return readOnlyValueTypeArray;
+      if (ReadOnly) return this;
+      var clone = (ValueTypeArray<T>)this.Clone();
+      clone.readOnly = true;
+      return clone;
     }
 
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/ValueTypeMatrix.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/ValueTypeMatrix.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/ValueTypeMatrix.cs	(revision 17253)
@@ -190,8 +190,8 @@
 
     public virtual ValueTypeMatrix<T> AsReadOnly() {
-      if (readOnly) return this;
-      var readOnlyValueTypeMatrix = (ValueTypeMatrix<T>)this.Clone();
-      readOnlyValueTypeMatrix.readOnly = true;
-      return readOnlyValueTypeMatrix;
+      if (ReadOnly) return this;
+      var clone = (ValueTypeMatrix<T>)this.Clone();
+      clone.readOnly = true;
+      return clone;
     }
 
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/ValueTypeValue.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/ValueTypeValue.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Data/3.3/ValueTypeValue.cs	(revision 17253)
@@ -22,7 +22,7 @@
 using System;
 using System.Drawing;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HEAL.Attic;
 
 namespace HeuristicLab.Data {
@@ -64,13 +64,14 @@
       this.readOnly = false;
     }
-    protected ValueTypeValue(T value) {
+    protected ValueTypeValue(T value, bool @readonly = false) {
       this.value = value;
-      this.readOnly = false;
+      this.readOnly = @readonly;
     }
 
     public virtual ValueTypeValue<T> AsReadOnly() {
-      ValueTypeValue<T> readOnlyValueTypeValue = (ValueTypeValue<T>)this.Clone();
-      readOnlyValueTypeValue.readOnly = true;
-      return readOnlyValueTypeValue;
+      if (ReadOnly) return this;
+      var clone = (ValueTypeValue<T>)this.Clone();
+      clone.readOnly = true;
+      return clone;
     }
 
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Instances/3.3/Types/DistanceHelper.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Instances/3.3/Types/DistanceHelper.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Instances/3.3/Types/DistanceHelper.cs	(revision 17253)
@@ -90,9 +90,9 @@
     }
 
-    private static double AttDistance(double x1, double y1, double x2, double y2) {
+    public static double AttDistance(double x1, double y1, double x2, double y2) {
       return Math.Ceiling(Math.Sqrt(((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2)) / 10.0));
     }
 
-    private static double EuclideanDistance(double x1, double y1, double x2, double y2) {
+    public static double EuclideanDistance(double x1, double y1, double x2, double y2) {
       return Math.Sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
     }
@@ -100,5 +100,5 @@
     private const double PI = 3.141592;
     private const double RADIUS = 6378.388;
-    private static double GeoDistance(double x1, double y1, double x2, double y2) {
+    public static double GeoDistance(double x1, double y1, double x2, double y2) {
       double latitude1, longitude1, latitude2, longitude2;
       double q1, q2, q3;
@@ -122,9 +122,9 @@
     }
 
-    private static double ManhattanDistance(double x1, double y1, double x2, double y2) {
+    public static double ManhattanDistance(double x1, double y1, double x2, double y2) {
       return Math.Round(Math.Abs(x1 - x2) + Math.Abs(y1 - y2), MidpointRounding.AwayFromZero);
     }
 
-    private static double MaximumDistance(double x1, double y1, double x2, double y2) {
+    public static double MaximumDistance(double x1, double y1, double x2, double y2) {
       return Math.Max(Math.Round(Math.Abs(x1 - x2), MidpointRounding.AwayFromZero), Math.Round(Math.Abs(y1 - y2), MidpointRounding.AwayFromZero));
     }
